1
0

install.sh 9.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64) echo 'amd64' ;;
  24. i*86 | x86) echo '386' ;;
  25. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  26. armv7* | armv7 | arm) echo 'armv7' ;;
  27. armv6* | armv6) echo 'armv6' ;;
  28. armv5* | armv5) echo 'armv5' ;;
  29. s390x) echo 's390x' ;;
  30. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  31. esac
  32. }
  33. echo "arch: $(arch)"
  34. os_version=""
  35. os_version=$(grep "^VERSION_ID" /etc/os-release | cut -d '=' -f2 | tr -d '"')
  36. if [[ "${release}" == "arch" ]]; then
  37. echo "Your OS is Arch Linux"
  38. elif [[ "${release}" == "parch" ]]; then
  39. echo "Your OS is Parch Linux"
  40. elif [[ "${release}" == "manjaro" ]]; then
  41. echo "Your OS is Manjaro"
  42. elif [[ "${release}" == "armbian" ]]; then
  43. echo "Your OS is Armbian"
  44. elif [[ "${release}" == "opensuse-tumbleweed" ]]; then
  45. echo "Your OS is OpenSUSE Tumbleweed"
  46. elif [[ "${release}" == "centos" ]]; then
  47. if [[ ${os_version} -lt 8 ]]; then
  48. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  49. fi
  50. elif [[ "${release}" == "ubuntu" ]]; then
  51. if [[ ${os_version} -lt 20 ]]; then
  52. echo -e "${red} Please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  53. fi
  54. elif [[ "${release}" == "fedora" ]]; then
  55. if [[ ${os_version} -lt 36 ]]; then
  56. echo -e "${red} Please use Fedora 36 or higher version!${plain}\n" && exit 1
  57. fi
  58. elif [[ "${release}" == "amzn" ]]; then
  59. if [[ ${os_version} != "2023" ]]; then
  60. echo -e "${red} Please use Amazon Linux 2023!${plain}\n" && exit 1
  61. fi
  62. elif [[ "${release}" == "debian" ]]; then
  63. if [[ ${os_version} -lt 11 ]]; then
  64. echo -e "${red} Please use Debian 11 or higher ${plain}\n" && exit 1
  65. fi
  66. elif [[ "${release}" == "almalinux" ]]; then
  67. if [[ ${os_version} -lt 9 ]]; then
  68. echo -e "${red} Please use AlmaLinux 9 or higher ${plain}\n" && exit 1
  69. fi
  70. elif [[ "${release}" == "rocky" ]]; then
  71. if [[ ${os_version} -lt 9 ]]; then
  72. echo -e "${red} Please use Rocky Linux 9 or higher ${plain}\n" && exit 1
  73. fi
  74. elif [[ "${release}" == "oracle" ]]; then
  75. if [[ ${os_version} -lt 8 ]]; then
  76. echo -e "${red} Please use Oracle Linux 8 or higher ${plain}\n" && exit 1
  77. fi
  78. else
  79. echo -e "${red}Your operating system is not supported by this script.${plain}\n"
  80. echo "Please ensure you are using one of the following supported operating systems:"
  81. echo "- Ubuntu 20.04+"
  82. echo "- Debian 11+"
  83. echo "- CentOS 8+"
  84. echo "- Fedora 36+"
  85. echo "- Arch Linux"
  86. echo "- Parch Linux"
  87. echo "- Manjaro"
  88. echo "- Armbian"
  89. echo "- AlmaLinux 9+"
  90. echo "- Rocky Linux 9+"
  91. echo "- Oracle Linux 8+"
  92. echo "- OpenSUSE Tumbleweed"
  93. echo "- Amazon Linux 2023"
  94. exit 1
  95. fi
  96. install_base() {
  97. case "${release}" in
  98. ubuntu | debian | armbian)
  99. apt-get update && apt-get install -y -q wget curl tar tzdata
  100. ;;
  101. centos | almalinux | rocky | oracle)
  102. yum -y update && yum install -y -q wget curl tar tzdata
  103. ;;
  104. fedora)
  105. dnf -y update && dnf install -y -q wget curl tar tzdata
  106. ;;
  107. arch | manjaro | parch)
  108. pacman -Syu && pacman -Syu --noconfirm wget curl tar tzdata
  109. ;;
  110. opensuse-tumbleweed)
  111. zypper refresh && zypper -q install -y wget curl tar timezone
  112. ;;
  113. *)
  114. apt-get update && apt install -y -q wget curl tar tzdata
  115. ;;
  116. esac
  117. }
  118. gen_random_string() {
  119. local length="$1"
  120. local random_string=$(LC_ALL=C tr -dc 'a-zA-Z0-9' </dev/urandom | fold -w "$length" | head -n 1)
  121. echo "$random_string"
  122. }
  123. # This function will be called when user installed x-ui out of security
  124. config_after_install() {
  125. echo -e "${yellow}Install/update finished! For security it's recommended to modify panel settings ${plain}"
  126. read -p "Would you like to customize the panel settings? (If not, random settings will be applied) [y/n]: " config_confirm
  127. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  128. read -p "Please set up your username: " config_account
  129. echo -e "${yellow}Your username will be: ${config_account}${plain}"
  130. read -p "Please set up your password: " config_password
  131. echo -e "${yellow}Your password will be: ${config_password}${plain}"
  132. read -p "Please set up the panel port: " config_port
  133. echo -e "${yellow}Your panel port is: ${config_port}${plain}"
  134. read -p "Please set up the web base path (ip:port/webbasepath/): " config_webBasePath
  135. echo -e "${yellow}Your web base path is: ${config_webBasePath}${plain}"
  136. echo -e "${yellow}Initializing, please wait...${plain}"
  137. /usr/local/x-ui/x-ui setting -username ${config_account} -password ${config_password}
  138. echo -e "${yellow}Account name and password set successfully!${plain}"
  139. /usr/local/x-ui/x-ui setting -port ${config_port}
  140. echo -e "${yellow}Panel port set successfully!${plain}"
  141. /usr/local/x-ui/x-ui setting -webBasePath ${config_webBasePath}
  142. echo -e "${yellow}Web base path set successfully!${plain}"
  143. else
  144. echo -e "${red}Cancel...${plain}"
  145. if [[ ! -f "/etc/x-ui/x-ui.db" ]]; then
  146. local usernameTemp=$(head -c 6 /dev/urandom | base64)
  147. local passwordTemp=$(head -c 6 /dev/urandom | base64)
  148. local webBasePathTemp=$(gen_random_string 10)
  149. /usr/local/x-ui/x-ui setting -username ${usernameTemp} -password ${passwordTemp} -webBasePath ${webBasePathTemp}
  150. echo -e "This is a fresh installation, will generate random login info for security concerns:"
  151. echo -e "###############################################"
  152. echo -e "${green}Username: ${usernameTemp}${plain}"
  153. echo -e "${green}Password: ${passwordTemp}${plain}"
  154. echo -e "${green}WebBasePath: ${webBasePathTemp}${plain}"
  155. echo -e "###############################################"
  156. echo -e "${yellow}If you forgot your login info, you can type "x-ui settings" to check after installation${plain}"
  157. else
  158. echo -e "${yellow}This is your upgrade, will keep old settings. If you forgot your login info, you can type "x-ui settings" to check${plain}"
  159. fi
  160. fi
  161. /usr/local/x-ui/x-ui migrate
  162. }
  163. install_x-ui() {
  164. cd /usr/local/
  165. if [ $# == 0 ]; then
  166. last_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  167. if [[ ! -n "$last_version" ]]; then
  168. echo -e "${red}Failed to fetch x-ui version, it maybe due to Github API restrictions, please try it later${plain}"
  169. exit 1
  170. fi
  171. echo -e "Got x-ui latest version: ${last_version}, beginning the installation..."
  172. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch).tar.gz
  173. if [[ $? -ne 0 ]]; then
  174. echo -e "${red}Downloading x-ui failed, please be sure that your server can access Github ${plain}"
  175. exit 1
  176. fi
  177. else
  178. last_version=$1
  179. url="https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch).tar.gz"
  180. echo -e "Beginning to install x-ui $1"
  181. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz ${url}
  182. if [[ $? -ne 0 ]]; then
  183. echo -e "${red}Download x-ui $1 failed,please check the version exists ${plain}"
  184. exit 1
  185. fi
  186. fi
  187. if [[ -e /usr/local/x-ui/ ]]; then
  188. systemctl stop x-ui
  189. rm /usr/local/x-ui/ -rf
  190. fi
  191. tar zxvf x-ui-linux-$(arch).tar.gz
  192. rm x-ui-linux-$(arch).tar.gz -f
  193. cd x-ui
  194. chmod +x x-ui
  195. # Check the system's architecture and rename the file accordingly
  196. if [[ $(arch) == "armv5" || $(arch) == "armv6" || $(arch) == "armv7" ]]; then
  197. mv bin/xray-linux-$(arch) bin/xray-linux-arm
  198. chmod +x bin/xray-linux-arm
  199. fi
  200. chmod +x x-ui bin/xray-linux-$(arch)
  201. cp -f x-ui.service /etc/systemd/system/
  202. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  203. chmod +x /usr/local/x-ui/x-ui.sh
  204. chmod +x /usr/bin/x-ui
  205. config_after_install
  206. systemctl daemon-reload
  207. systemctl enable x-ui
  208. systemctl start x-ui
  209. echo -e "${green}x-ui ${last_version}${plain} installation finished, it is running now..."
  210. echo -e ""
  211. echo -e "x-ui control menu usages: "
  212. echo -e "----------------------------------------------"
  213. echo -e "SUBCOMMANDS:"
  214. echo -e "x-ui - Admin Management Script"
  215. echo -e "x-ui start - Start"
  216. echo -e "x-ui stop - Stop"
  217. echo -e "x-ui restart - Restart"
  218. echo -e "x-ui status - Current Status"
  219. echo -e "x-ui settings - Current Settings"
  220. echo -e "x-ui enable - Enable Autostart on OS Startup"
  221. echo -e "x-ui disable - Disable Autostart on OS Startup"
  222. echo -e "x-ui log - Check logs"
  223. echo -e "x-ui banlog - Check Fail2ban ban logs"
  224. echo -e "x-ui update - Update"
  225. echo -e "x-ui custom - custom version"
  226. echo -e "x-ui install - Install"
  227. echo -e "x-ui uninstall - Uninstall"
  228. echo -e "----------------------------------------------"
  229. }
  230. echo -e "${green}Running...${plain}"
  231. install_base
  232. install_x-ui $1